package com.steerinfo.dil.feign;

import com.steerinfo.framework.controller.RESTfulResult;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.HashMap;
import java.util.Map;
@FeignClient(value = "DAL-OTMS-API-DEV", url = "${openfeign.OTMSFeign.url}")
public interface OtmsFeign {
    //在途订单列表
    @PostMapping("/api/v1/otms/pathDisplay/getInTransitTransportation")
    public RESTfulResult getInTransitTransportation(@RequestBody Map<String,Object> mapValue,
                                                    @RequestParam(required = true,defaultValue = "468",name = "apiId")Integer apiId,
                                                    @RequestParam(required = false,name = "pageNum")Integer pageNum,
                                                    @RequestParam(required = false,name = "pageSize")Integer pageSize);
    //已完成订单列表
    @PostMapping("/api/v1/otms/pathDisplay/getFinishTruckOrderInfo")
    public RESTfulResult getFinishTruckOrderInfo(@RequestBody Map<String,Object> mapValue,
                                                 @RequestParam(required = true,defaultValue = "468",name = "apiId")Integer apiId,
                                                 @RequestParam(required = false,defaultValue = "1",name = "pageNum")Integer pageNum,
                                                 @RequestParam(required = false,defaultValue = "20",name = "pageSize")Integer pageSize
    );
    //有异常订单列表
    @PostMapping("/api/v1/otms/pathDisplay/getHaveAbnormalTruckOrderInfo")
    public RESTfulResult getHaveAbnormalTruckOrderInfo(@RequestBody Map<String,Object> mapValue,
                                                       @RequestParam(required = true,defaultValue = "468",name = "apiId")Integer apiId,
                                                       @RequestParam(required = false,name = "pageNum")Integer pageNum,
                                                       @RequestParam(required = false,name = "pageSize")Integer pageSize);
    //车牌号和时间查询路径
    @PostMapping("/api/v1/otms/pathDisplay/fullPathVisualizationByCarNumber")
    public Object fullPathVisualizationByCarNumber(@RequestBody HashMap mapValue);

    //改变当前报警类型
    @PostMapping(value = "/api/v1/otms/pathDisplay/inTransitWarn")
    public RESTfulResult inTransitWarn(@RequestParam String warnSwitch,@RequestParam String radio);


    //查询当前报警类型
    @PostMapping(value = "/api/v1/otms/pathDisplay/selectWarnSwitch")
    public RESTfulResult selectWarnSwitch();

    //通过运输订单号查询全路径
    @PostMapping("/api/v1/otms/pathDisplay/fullPath")
    public Object fullPath(@RequestParam("orderNumber") String orderNumber) throws Exception;

    //获得抵达列表
//    @PostMapping("/api/v1/otms/tmstruckarrivalresults/getArrivalResultInfo")
//    Map<String, Object> getArrivalResultInfo(@RequestBody(required = false) Map<String, Object> mapValue,
//                                         @RequestParam Integer apiId,
//                                         @RequestParam Integer pageNum,
//                                         @RequestParam Integer pageSize,
//                                         @RequestParam String con,
//                                         @RequestParam String startTime,
//                                         @RequestParam String endTime
//    );

    //通过运输订单号获得抵达图片
    @PostMapping("/api/v1/otms/tmstruckreceiptresults/getArrivalPhoto")
    String getReceiptPhoto(@RequestParam String orderNumber);

    //获取收货作业照片
    @PostMapping("/api/v1/otms/tmstruckreceiptresults/getReceivingPhotoByUrl")
    public Map<String,Object> getReceivingPhotoByUrl(@RequestParam String orderNumber);

    //获得抵达实集
    @PostMapping(value = "/api/v1/otms/tmstruckarrivalresults/addtmstruckArrivalResult",consumes = MediaType.MULTIPART_FORM_DATA_VALUE)
    public RESTfulResult addtmstruckArrivalResult(@RequestParam("orderNumber")String orderNumber, @RequestParam("resultArrivalAddress")String resultArrivalAddress,@RequestPart("file") MultipartFile file);

    //添加签收图片
    @PostMapping(value = "/api/v1/otms/pathDisplay/addTmstruckReceiptResult")
    public  RESTfulResult addTmstruckReceiptResult(@RequestBody Map<String,Object>  mapValaue  , @RequestParam("num") Integer num, @RequestParam("orderNumber")  String orderNumber, @RequestParam("resultArrivalAddress")String resultArrivalAddress, @RequestParam("imgcount3") Integer imgcount3, @RequestParam("imgcount4")Integer imgcount4);

    //获得异常信息
    @PostMapping("/api/v1/otms/pathDisplay/getTransportAbnormalInfo")
    public RESTfulResult getTransportAbnormalInfo(@RequestBody(required=false) Map<String,Object> mapValue,
                                                  @RequestParam(name = "apiId",defaultValue = "472") Integer apiId,
                                                  @RequestParam(name = "pageNum") Integer pageNum,
                                                  @RequestParam(name = "pageSize") Integer pageSize);

    //抵达信息列表
    @PostMapping("/api/v1/otms/tmstruckreceiptresults/getArrivalResult")
    Map<String, Object> getArrivalResult(@RequestBody(required = false) Map<String, Object> mapValue,
                                         @RequestParam Integer apiId,
                                         @RequestParam Integer pageNum,
                                         @RequestParam Integer pageSize,
                                         @RequestParam String con,
                                         @RequestParam String startTime,
                                         @RequestParam String endTime);

    //获得抵达图片
    @PostMapping("/api/v1/otms/tmstruckreceiptresults/getArrivalPhoto")
    String getArrivalPhoto(@RequestParam String orderNumber);

    //获得签收实绩
    @PostMapping("/api/v1/otms/pathDisplay/getReceiptResult")
    Map<String, Object> getReceiptResult(@RequestBody(required = false) Map<String, Object> mapValue,
                                         @RequestParam Integer apiId,
                                         @RequestParam Integer pageNum,
                                         @RequestParam Integer pageSize,
                                         @RequestParam String con,
                                         @RequestParam String startTime,
                                         @RequestParam String endTime
    );
    @GetMapping("/api/v1/otms/pathDisplay/getCurrentLocation")
    public RESTfulResult getCurrentLocation(@RequestParam("capcityNumber") String capcityNumber) throws Exception;
}
